SystemOrganization addCategory: #'OpalCompiler-Shout'!

MethodCodeStyler subclass: #OCMethodCodeStyler
	instanceVariableNames: 'visitor request'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Shout'!

!OCMethodCodeStyler methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 12/23/2011 14:56'!
initialize
	request := MethodParseRequest new.
	visitor := OCASTShoutVisitor new.
! !

!OCMethodCodeStyler methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 4/3/2013 18:06'!
rangeSyntaxAttributesFor: aString in: aClassOrMetaclass workspace: workspace env: env
	|ast|
	request source: aString.
	[ast := request sendTo: aClassOrMetaclass] on: Error do: [^#()].
	ast isCollection ifTrue: [ ast := ast first ].
	visitor reset.
	visitor methodClass: aClassOrMetaclass.
	visitor visitNode: ast.
	^visitor collection.
! !

!OCMethodCodeStyler methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/29/2011 23:04'!
styleArray
	"color can be a valid argument to Color class>>colorFrom: , or nil to
	use the editor text color.
	Multiple emphases can be specified using an array e.g. #(bold italic).
	If emphasis is not specified, #normal will be used.
	if pixel height is not specified , then the editor font size will be used.
	"
								
 ^ #(
       "(symbol        color           [emphasisSymbolOrArray          [textStyleName [pixelHeight]]])"                
       (default                                                                black           )
       (invalid                                                                red                     )
       (excessCode                                                             red                     )
       (comment                                                                (green muchDarker)              italic)
       (unfinishedComment                                      (red muchDarker)        italic)
       (#'$'                                                                   (red muchDarker)        )
       (character                                                              (red muchDarker)        )
       (integer                                                                        (red muchDarker)        )
       (number                                                         (red muchDarker)        )      
       (#-                                                                             (red muchDarker)        )
       (symbol                                                                 (blue muchDarker)                       normal)  
       (stringSymbol                                                   (blue muchDarker)                       normal)  
       (literalArray                                                   (blue muchDarker)                       normal)
       (string                                                                 (magenta muchDarker)    normal)
       (unfinishedString                                               red                     normal          )
       (assignment                                                             nil                     normal                    )
       (ansiAssignment                                                 nil                     normal)
       (literal                                                                        nil                     italic)
       (keyword                                                                (blue muchDarker)                       )
       (binary                                                                 (blue muchDarker)                       )      
       (unary                                                                  (blue muchDarker)                       )
       (incompleteKeyword                                              (gray muchDarker)                       underlined)
       (incompleteBinary                                               (gray muchDarker)                       underlined)    
       (incompleteUnary                                                (gray muchDarker)                       underlined)
       (undefinedKeyword                                               red                     )
       (undefinedBinary                                                red                     )      
       (undefinedUnary                                         red                     )                                                                                                      
       (patternKeyword                                                 nil                     bold)
       (patternBinary                                                  nil                     bold)
       (patternUnary                                                   nil                     bold)  
       (#self                                                                  (red muchDarker)        normal)
       (#super                                                                 (red muchDarker)        normal)
       (#true                                                                  (red muchDarker)        normal)
       (#false                                                                         (red muchDarker)        normal)
       (#nil                                                                   (red muchDarker)        normal)
       (#thisContext                                                   (red muchDarker)        normal)
       (#return                                                                (red muchDarker)        normal)
       (patternArg                                                     (blue muchDarker)                       italic)
       (methodArg                                                              (blue muchDarker)                       italic)
       (blockPatternArg                                                (blue muchDarker)                       italic)
       (blockArg                                                               (blue muchDarker)                       italic)
       (argument                                                               (blue muchDarker)                       italic)
       (blockArgColon                                                  black           )
       (leftParenthesis                                                        black           )
       (rightParenthesis                                               black           )
       (leftParenthesis1                                               (green muchDarker)              )
       (rightParenthesis1                                              (green muchDarker)              )
       (leftParenthesis2                                               (magenta muchDarker)            )
       (rightParenthesis2                                              (magenta muchDarker)            )
       (leftParenthesis3                                               (red muchDarker)                )
       (rightParenthesis3                                              (red muchDarker)                )
       (leftParenthesis4                                               (green darker)          )
       (rightParenthesis4                                              (green darker)          )
       (leftParenthesis5                                               (orange darker)         )
       (rightParenthesis5                                              (orange darker)         )
       (leftParenthesis6                                               (magenta darker)                )
       (rightParenthesis6                                              (magenta darker)                )
       (leftParenthesis7                                               blue            )
       (rightParenthesis7                                              blue            )
       (blockStart                                                             black           )
       (blockEnd                                                               black           )
       (blockStart1                                                            (green muchDarker)                      )
       (blockEnd1                                                              (green muchDarker)                      )
       (blockStart2                                                            (magenta muchDarker)            )
       (blockEnd2                                                              (magenta muchDarker)            )
       (blockStart3                                                            (red muchDarker)                )
       (blockEnd3                                                              (red muchDarker)                )
       (blockStart4                                                            (green darker)          )
       (blockEnd4                                                              (green darker)          )
       (blockStart5                                                            (orange darker)         )
       (blockEnd5                                                              (orange darker)         )
       (blockStart6                                                            (magenta darker)                )
       (blockEnd6                                                              (magenta darker)                )
       (blockStart7                                                            blue            )
       (blockEnd7                                                              blue            )                                                                                                                                                                                                                                                                                                                                                                                                      
       (arrayStart                                                             black           )
       (arrayEnd                                                               black           )
       (arrayStart1                                                    black           )
       (arrayEnd1                                                              black           )
       (leftBrace                                                              black           )
       (rightBrace                                                             black           )
       (cascadeSeparator                                               black           )
       (statementSeparator                                             black           )
       (externalCallType                                               black           )
       (externalCallTypePointerIndicator               black           )
       (primitiveOrExternalCallStart                   black   bold    )
       (primitiveOrExternalCallEnd                             black   bold    )
       (methodTempBar                                                  gray            )
       (blockTempBar                                                   gray            )
       (blockArgsBar                                                   gray            )
       (primitive                                                              (green muchDarker)              italic)
       (pragmaKeyword                                          (green muchDarker)              bold)
       (pragmaUnary                                                    (green muchDarker)              bold)
       (pragmaBinary                                                   (green muchDarker)              bold)                                                                  
       (externalFunctionCallingConvention              (green muchDarker)              bold)
       (module                                                                 (green muchDarker)              bold)
       (blockTempVar                                                   gray            italic)
       (blockPatternTempVar                                    gray            italic)
       (instVar                                                                black           normal)
       (workspaceVar                                                   black           bold)
       (undefinedIdentifier                                            red                     bold)
       (incompleteIdentifier                                   (gray darker)   (italic underlined))
       (tempVar                                                                (gray darker)   italic)
       (patternTempVar                                         (gray darker)   italic)
       (poolConstant                                                   (gray darker)   italic)
       (classVar                                                               (gray darker)   normal)
       (globalVar                                                              black           normal) )! !

RBProgramNodeVisitor subclass: #OCASTShoutVisitor
	instanceVariableNames: 'collection methodClass dict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Shout'!

!OCASTShoutVisitor methodsFor: 'visitor-double dispatching' stamp: 'EstebanAllende 11/29/2011 23:56'!
acceptArrayNode: anArrayNode 
	self addInteger: anArrayNode left withAttribute: #leftBrace.
	super acceptArrayNode: anArrayNode.
	self addInteger: anArrayNode right withAttribute: #rightBrace.
	! !

!OCASTShoutVisitor methodsFor: 'visitor-double dispatching' stamp: 'EstebanAllende 11/29/2011 23:56'!
acceptAssignmentNode: anAssignmentNode
	|a|
	self visitNode: anAssignmentNode variable.
	a := anAssignmentNode assignment.
	anAssignmentNode assignmentOperator = ':='
		ifTrue: [self addInterval: (a to: a + 1) withAttribute: #ansiAssignment]
		ifFalse: [self addInteger: a withAttribute: #assignment].
	self visitNode: anAssignmentNode value.! !

!OCASTShoutVisitor methodsFor: 'visitor-double dispatching' stamp: 'EstebanAllende 11/29/2011 23:57'!
acceptBlockNode: aBlockNode 
	self addInteger: aBlockNode left withAttribute: #blockStart.
	"self visitArguments: aBlockNode arguments."
	self visitNode: aBlockNode body.
	self addInteger: aBlockNode right withAttribute: #blockEnd.! !

!OCASTShoutVisitor methodsFor: 'visitor-double dispatching' stamp: 'EstebanAllende 11/29/2011 23:16'!
acceptCascadeNode: aCascadeNode 
	aCascadeNode messages do: [:each | self visitNode: each]! !

!OCASTShoutVisitor methodsFor: 'visitor-double dispatching' stamp: 'EstebanAllende 11/29/2011 23:16'!
acceptLiteralArrayNode: aRBLiteralArrayNode 
	aRBLiteralArrayNode contents do: [:each | self visitNode: each]! !

!OCASTShoutVisitor methodsFor: 'visitor-double dispatching' stamp: 'EstebanAllende 11/30/2011 00:14'!
acceptLiteralNode: aLiteralNode 
	|v t a|
	v := aLiteralNode value.
	t := aLiteralNode token.
	a := nil.
	(v isNil) ifTrue: [	a := #nil].
	(v = true) ifTrue: [a :=#true].
	(v = false) ifTrue: [a :=#false].
	(v isNumber) ifTrue: [a := #number].
	(v isString) ifTrue: [a := #string].
	(v isSymbol) ifTrue: [a := #symbol].
	(v isCharacter) ifTrue: [a := #character].
	self addToken: t withAttribute: a.! !

!OCASTShoutVisitor methodsFor: 'visitor-double dispatching' stamp: 'EstebanAllende 1/15/2013 12:22'!
acceptMessageNode: aMessageNode 
	|args sParts|
	(aMessageNode isCascaded not
			or: [aMessageNode isFirstCascaded])
		ifTrue: [	self visitNode: aMessageNode receiver].
	
	args := aMessageNode arguments.
	sParts := aMessageNode selectorParts.
	(args size = 0) 
		ifTrue: [self addToken: sParts first withAttribute: #unary]
		ifFalse: [
			sParts first isKeyword
				ifFalse: [
					self addToken: sParts first withAttribute: #binary.
					self visitNode: args first.
					]
				ifTrue: [ 1 to: args size do: [:i|
						self addToken: (sParts at: i) withAttribute: #keyword.
						self visitNode: (args at: i).
					]]
		].	! !

!OCASTShoutVisitor methodsFor: 'visitor-double dispatching' stamp: 'EstebanAllende 2/20/2013 12:45'!
acceptMethodNode: aMethodNode 
	"Modificar"
	|arguments sParts|
	arguments := aMethodNode arguments.
	sParts := aMethodNode selectorParts.
	(arguments size = 0)
		ifTrue: [self addToken: sParts first withAttribute: #patternUnary]
		ifFalse: [sParts first isKeyword
					ifFalse: [self addToken: sParts first withAttribute: #patternBinary.
							self addToken: arguments first withAttribute: #patternArg]
					ifTrue: [1 to: arguments size do: [:i|
							self addToken: (sParts at: i) withAttribute: #patternKeyword.
							self addToken: (arguments at: i) withAttribute: #patternArg
					]]
				 ].
	self visitNode: aMethodNode body! !

!OCASTShoutVisitor methodsFor: 'visitor-double dispatching' stamp: 'EstebanAllende 11/29/2011 23:16'!
acceptPatternBlockNode: aRBPatternBlockNode 
	self visitArguments: aRBPatternBlockNode arguments.
	self visitNode: aRBPatternBlockNode body! !

!OCASTShoutVisitor methodsFor: 'visitor-double dispatching' stamp: 'EstebanAllende 11/29/2011 23:16'!
acceptPatternWrapperBlockNode: aRBPatternWrapperBlockNode 
	self visitNode: aRBPatternWrapperBlockNode wrappedNode.
	self visitArguments: aRBPatternWrapperBlockNode arguments.
	self visitNode: aRBPatternWrapperBlockNode body! !

!OCASTShoutVisitor methodsFor: 'visitor-double dispatching' stamp: 'EstebanAllende 11/29/2011 23:16'!
acceptPragmaNode: aPragmaNode
	aPragmaNode arguments do: [ :each | self visitNode: each ]! !

!OCASTShoutVisitor methodsFor: 'visitor-double dispatching' stamp: 'EstebanAllende 11/29/2011 23:59'!
acceptReturnNode: aReturnNode
	self addInteger: aReturnNode return withAttribute: #return. 
	self visitNode: aReturnNode value.! !

!OCASTShoutVisitor methodsFor: 'visitor-double dispatching' stamp: 'EstebanAllende 12/23/2011 12:05'!
acceptSequenceNode: aSequenceNode 
	aSequenceNode leftBar ifNotNil: [self addInteger: aSequenceNode leftBar withAttribute: #methodTempBar.
	aSequenceNode temporaries do: [:each| self addToken: each token withAttribute: #patternTempVar].
	self addInteger: aSequenceNode rightBar withAttribute: #methodTempBar].

	aSequenceNode periods do: [:dot | self addInteger: dot withAttribute: #statementSeparator].
	aSequenceNode statements do:[:each|self visitNode: each].! !

!OCASTShoutVisitor methodsFor: 'visitor-double dispatching' stamp: 'EstebanAllende 11/30/2011 00:08'!
acceptVariableNode: aVariableNode 
	|token value|
	value := aVariableNode name asSymbol.
	((value = #self) | (value = #super) | (value = #thisContext)) ifTrue: [^self addToken: aVariableNode token withAttribute: value]! !

!OCASTShoutVisitor methodsFor: 'support methods' stamp: 'EstebanAllende 11/29/2011 23:54'!
addInteger: aInteger withAttribute: aSymbol
	|res|
	res := SHRange new.
	res start: aInteger.
	res end: aInteger.
	res type: aSymbol.
	collection addLast: res.
	! !

!OCASTShoutVisitor methodsFor: 'support methods' stamp: 'EstebanAllende 11/29/2011 23:54'!
addInterval: anInterval withAttribute: aSymbol
	|res|
	res := SHRange new.
	res start: anInterval first.
	res end: anInterval last.
	res type: aSymbol.
	collection addLast: res.
	
	! !

!OCASTShoutVisitor methodsFor: 'support methods' stamp: 'EstebanAllende 11/29/2011 23:55'!
addToken: aToken withAttribute: aSymbol
	|res|
	res := SHRange new.
	res start: aToken start.
	res end: aToken stop.
	res type: aSymbol.
	collection addLast: res.
	
	
	! !

!OCASTShoutVisitor methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/29/2011 23:25'!
collection
	^collection! !

!OCASTShoutVisitor methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/29/2011 23:28'!
methodClass
	^methodClass! !

!OCASTShoutVisitor methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/29/2011 23:28'!
methodClass: aClass
	methodClass := aClass! !

!OCASTShoutVisitor methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/29/2011 23:46'!
reset
	collection := OrderedCollection new.
	dict := Dictionary new.! !

!OCASTShoutVisitor methodsFor: 'visiting' stamp: 'EstebanAllende 11/29/2011 23:16'!
visitArgument: each 
	"Here to allow subclasses to detect arguments or temporaries."

	^self visitNode: each! !

!OCASTShoutVisitor methodsFor: 'visiting' stamp: 'EstebanAllende 11/29/2011 23:16'!
visitArguments: aNodeCollection 
	^aNodeCollection do: [:each | self visitArgument: each]! !

!OCASTShoutVisitor methodsFor: 'visiting' stamp: 'EstebanAllende 12/23/2011 12:02'!
visitNode: aNode 
	super visitNode: aNode.
	aNode comments do: [:interval| self addInterval: interval withAttribute: #comment].! !

CodeStyler subclass: #OCCodeStyler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Shout'!

!OCCodeStyler methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/29/2011 23:38'!
methodStyler
	^methodStyler ifNil: [methodStyler := OCMethodCodeStyler new].
! !
